function ret = bubblexmd ( M , v , L , alpha , x , mean , dx,dt,style ) 
# do a bubble tour of a gaussian 
# making plots versus x as we go 
# includes a mean vector 
# and data too
 if ((nargin != 8)&&(nargin != 9))
    usage ("bubblex ( M , v , L , alpha , x , m ,dx,dt[,style] )");
  endif
if (nargin != 7)
# need to fix up style
	style = "-@13" ;
endif
pointstyle = "@33" ; 
vl=[] ; 	
for l=1:L
	v = alpha * v + sqrt((1.0-alpha^2)) * randn(size(v))*M  ;
	vtot = v + mean ;
	vl(l,:) = [vtot] ;
	plot(x,vtot,style,dx,dt,pointstyle) ;
endfor
ret = vl ;
endfunction
