# usage 
# demo1d
r=2;
rmin=0.6;  rmax=3;
rmin2=0.3; rmax2=17;
rmin13=0.2;  rmax13=4;
Amin=0.03 ; Amax=3.4;
S=12;                     # number of samples
SS=50; # number of  samples in 2d plot
SSS=15; # more modest number for lines
movieS=30;                     # number of samples
varymovieS=10;                     # number of samples
pausetime = 0.3 ;
pausetimeA = 0.1 ;
memory=0.9; 
global jitter = 1e-6 ;
global A ; 
#
# define data
#
state = 0 ; State = 12 ;
while (1)
 ans = mymenu("Gaussian distribution",
 "2-d(in 2d)",
 "2-d",
 "6-d" ,
 "13-d",
 "6-d again",
 "13-d(varying r), bubble",
 "13, varying r, show mean",
 "2-d, varying r",
 "13-d, varying r, mean, logPr",
 "13-d, varying r, bubble, logPr",
 "2-d, varying A",
 "quit" ) ;
 if ( ans == 0 ) 
	state ++ ; 
	if ( state > State )  # cycle through optinos
		state = 1 ; 
	endif
 else
	state = ans ;
 endif

	initgnu();			# set up graphics
        A = 1 ; 
 if ( state == 1 ) 
# "Two dimensional Gaussian distribution"
  x=[1,2] ;
  o=[1,0] ;
  t=[1] ;
  demo2d(x,o,t,r,SS,movieS,0,1); # 0 for no memory
  demo2d(x,o,t,r/3,SS,movieS,0,1); # 0 for no memory
  demo2d(x,o,t,r*3,SS,movieS,0,1); # 0 for no memory

 elseif (state==2)
# "Two dimensional Gaussian distribution"
  x=[1,2] ;
  o=[1,0] ;
  t=[1] ;
  restore525;
  demoxot(x,o,t,r,SSS,movieS,0,2); # 0 for no memory , 1/2 for verbose,ver verbose

 elseif (state==3)
#("Six dimensional Gaussian distribution","s") ;
  x=[1,2,3,4,5,6] ;
  o=[1,1,0,0,0,1] ;
  t=[1,1.25,0.1] ;
  demoxot(x,o,t,r,S,movieS,memory,1);

 elseif ( state == 4 )
#("13 dimensional Gaussian distribution","s") ;
  x=[0, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5, 5.5, 6 , 7] ;
  gset xrange [-0.5:7.5] ;
  o=[0,0,0,0,0,1,0,1,0,1,0,0,0] ;
  t=[-1,-1.25,-0.1] ;
  demoxot(x,o,t,r,S,movieS,memory,0);

 elseif (state==5)
#("see that Six dimensional Gaussian distribution again
  x=[1,2,3,4,5,6] ;
  verbose = 1 ; 
 BBIM;
 s=size(x); X=s(2);
 v=randn(S,X)*M ;
 lstyle = "-@13" ; # style for line samples
 plot ( x,v,lstyle)
 input("press return");

 elseif ( state == 6 )
#("13 dimensional Gaussian distribution - vary r
  x=[0, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5, 5.5, 6 , 7] ;
  gset xrange [-0.5:7.5] ;
  gset xrange [-0.5:7.5] ;
  o=[0,0,0,0,0,1,0,1,0,1,0,0,0] ;
  t=[-1,-1.25,-0.1] ;
#  demovaryr(x,o,t,rmin,rmax,varymovieS,memory,0);
#  demovaryr(x,o,t,rmin,rmax,varymovieS,memory,1);
  logPr = demovaryrP(x,o,t,rmin13,rmax13,varymovieS,memory,0,7,2);
  logPr = demovaryrP(x,o,t,rmin13,rmax13,varymovieS,memory,1,7,2);

 elseif ( state == 7 )
#13 dimensional Gaussian distribution - vary r and plot logPr, showing the mean
  x=[0, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5, 5.5, 6 , 7] ;
  gset xrange [-0.5:7.5] ;
  o=[0,0,0,0,0,1,0,1,0,1,0,0,0] ;
  t=[-1,-1.25,-0.1] ;
  logPr = demovaryrP(x,o,t,rmin13,rmax13,-1,memory,1,16,3);
#! don't  plotlogPr ;

 elseif ( state == 8 )
#("2 dimensional Gaussian distribution - vary r
#  x=[ 1, 2] ;  o=[1,1];  t=[0.9,0.56] ;
#  gset xrange [-0.5:6.5] ;	
#	plot ( x , t , "@43" ) ; 
#  input ( "DEMO : press return");
#  x=[0, 1, 2,3,4,5,6] ;  o=[0,1,1,0,0,0,0];  t=[0.9,0.56] ;
#  logPr = demovaryrP(x,o,t,rmin2,rmax2,-1,memory,1);
#  logPr = demovaryrP(x,o,t,rmin2,rmax2,5,memory,1);

  x=[ 1, 2] ;  o=[1,1];  t=[0.9,0.56] ;
  logPr = demovary2d(x,o,t,rmin2,rmax2,pausetime,memory,1);
  plotlogPr ;

#("2 dimensional Gaussian distribution - vary A
  gset xrange [-1:6.5] ;	
	plot ( x , t , "@43" ) ; 
  input ("press return") ;
  logPr = demovary2dA(x,t,r,Amin,Amax,pausetimeA,memory,1);
  plotlogPA ;

 elseif ( state == 9 )
#("13 dimensional Gaussian distribution - vary r and plot logPr
  x=[0, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5, 5.5, 6 , 7] ;
  gset xrange [-0.5:7.5] ;
  o=[0,0,0,0,0,1,0,1,0,1,0,0,0] ;
  t=[-1,-1.25,-0.1] ;
  logPr = demovaryrP(x,o,t,rmin13,rmax13,-1,memory,1);
  plotlogPr ;

 elseif ( state == 10 )
#("13 dimensional Gaussian distribution - vary r and plot logPr
  x=[0, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5, 5.5, 6 , 7] ;
  gset xrange [-0.5:7.5] ;
  o=[0,0,0,0,0,1,0,1,0,1,0,0,0] ;
  t=[-1,-1.25,-0.1] ;
  logPr = demovaryrP(x,o,t,rmin13,rmax13,varymovieS,memory,1);
  plotlogPr ;

 elseif ( state == 11 )
#("2 dimensional Gaussian distribution - vary A
  x=[ 1, 2] ;  o=[1,1];  t=[0.9,0.56] ;
  gset xrange [-1:6.5] ;	
	plot ( x , t , "@43" ) ; 
  input ("press return") ;
  x=[0, 1, 2,3,4,5,6] ;  o=[0,1,1,0,0,0,0];  t=[0.9,0.56] ;
  logPr = demovaryAP(x,o,t,r,Amin,Amax,-1,memory,1);
  logPr = demovaryAP(x,o,t,r,Amin,Amax,5,memory,1);

  x=[ 1, 2] ;  o=[1,1];  t=[0.9,0.56] ;
  logPr = demovary2dA(x,t,r,Amin,Amax,pausetimeA,memory,1);
  plotlogPA ;

 else
	break ;
 endif
endwhile


