function ret = demovary2d(x,o,t,rmin,rmax,pausetime,memory,data)
# usage 
# demovary2d(x,o,t,rmin,rmax,ptimre,memory,data)
# do a demo using inputs x, etc. - came from demoxot
#  if datainc = 0 then data are left out
#  if datainc = 1 then data are included
  if (nargin != 6 && nargin != 7 && nargin != 8)
    usage ("demovaryr(x,o,t,r,S,ptime[,memory[,data]])");
  endif
  if (nargin != 7  && nargin != 8)
	memory = 0.8 ; 
  endif
  if ( nargin != 8)
	data = 2 ; 
  endif
verbose = 0 ;
jitter = 1e-4 ;
restore25sq;

firsttime=1;
s=size(x); X=s(2);
style="@43";
lstyle = "-@13" ; # style for line samples
mstyle = "-4" ; # style for mean (green lines -14)
Nr=20; # must be 2 or more
Ud=4; # number of ups and downs
dlr = log(rmax/rmin) / ( Nr-1) ; 
dr0 = exp ( dlr ) ;
tt = t ;
logPr = [] ;

while ( 1 ) 
 r = rmin ; 
 dr = dr0 ;
 for  ud = 1:Ud
     for nr = 1:Nr
	BBIM ;
	command = sprintf ("gset title \"P( t1 , t2 | rho12 = %f )\"", B(1,2));
    	eval (command);
	contourstrue ;

	if ( data == 0 ) 
		gplot c1 u 1:2 w l 6 6 , c2 u 1:2 w l 6 6 ;
	else
		gplot c1 u 1:2 w l 6 6 , c2 u 1:2 w l 6 6 , tt u 1:2 w p 4 3 ;
		if ( firsttime ) 
			lp = logprob2d(BI,t)  ;
			logPr(nr,:) = [ r , B(1,2) , lp , exp(lp) ] ;
#			keyboard
		endif
	endif
	pause(pausetime) ; 

	r = r * dr ;
     endfor # nr
     if ( firsttime == 1 ) firstime = 0 ; endif
     dr = 1/dr ;
     r = r * dr ;
 endfor # ud
 s = input("to repeat slower, type factor - ");
 if ( s ) 
 else break ; endif
 pausetime = pausetime * s ; 
endwhile

gset title "";
ret = logPr ;


